=== examples/CMakeLists.txt ===
INSTALL(FILES
  example0.dawg
  example1.dawg
  example2.dawg
  example3.dawg
  example4.dawg
  DESTINATION "${CMAKE_DATA_DIR}/examples")
