=== debian/changelog ===
dawg (1.2-5) unstable; urgency=medium

  * Team upload.
  * Fix Build with CMake 4
    Closes: #1112828
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 17 Oct 2025 10:55:33 +0200

dawg (1.2-4) unstable; urgency=medium

  * Team upload.
  * Fix watch file
  * Standards-Version: 4.6.0 (routine-update)
  * Document issues with test (see upstream issue #56)

 -- Andreas Tille <tille@debian.org>  Mon, 08 Nov 2021 20:56:50 +0100

dawg (1.2-3) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * autopkgtest: s/ADTTMP/AUTOPKGTEST_TMP/g (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Mon, 16 Nov 2020 10:20:01 +0100

dawg (1.2-2) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload
  * Add citation
  * Homepage vanished but project is on Github - use this as homepage
  * cme fix dpkg-control
  * debhelper 11
  * d/watch: version=4
  * Fix short description
  * run build time test and add autopkgtest
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.5
  * Cleanup d/rules

  [ Steffen Möller ]
  * debian/upstream/metadata: Ref to OMICtools (Steffen Moeller)

 -- Andreas Tille <tille@debian.org>  Mon, 16 Jul 2018 09:10:34 +0200

dawg (1.2-1) unstable; urgency=low

  * Initial release (Closes: #806828)

 -- Kevin Murray <spam@kdmurray.id.au>  Tue, 01 Dec 2015 12:25:35 +1100
