=== debian/control ===
Source: dawg
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Kevin Murray <spam@kdmurray.id.au>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 bison,
 flex,
Vcs-Browser: https://salsa.debian.org/med-team/dawg
Vcs-Git: https://salsa.debian.org/med-team/dawg.git
Homepage: https://github.com/reedacartwright/dawg
Rules-Requires-Root: no

Package: dawg
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: simulate the evolution of recombinant DNA sequences
 DNA Assembly with Gaps (Dawg) is an application designed to simulate the
 evolution of recombinant DNA sequences in continuous time based on the robust
 general time reversible model with gamma and invariant rate heterogeneity and
 a novel length-dependent model of gap formation. The application accepts
 phylogenies in Newick format and can return the sequence of any node,
 allowing for the exact evolutionary history to be recorded at the discretion
 of users. Dawg records the gap history of every lineage to produce the true
 alignment in the output. Many options are available to allow users to
 customize their simulations and results.
